
public class DoubleBinarySearch {

	public static void main(String[] args) {
		int[][] sample = {{11, 13, 19},
						  {21, 34, 29, 42, 55},
						  {61},
						  {68, 74}};
				
		test(sample, 11, true);
		test(sample, 21, true);
		test(sample, 61, true);
		test(sample, 42, true);
		test(sample, 74, true);
		test(sample, 55, true);
		test(sample, 19, true);
		
		System.out.println();
		
		sample = new int[][]{{2, 4, 7, 9, 12},
							 {14, 16, 24, 33, 36, 66},
							 {78},
							 {90, 91, 92, 100},
							 {101, 105, 1000, 2000, 3000},
							 {3500}, 
							 {4500},
							 {5500},
							 {6000, 6001, 6002}};
		
		test(sample, 5, false);
		test(sample, 4500, true);
		test(sample, 6000, true);
		test(sample, 67, false);
		test(sample, 6002, true);
		test(sample, 555, false);
		test(sample, 2, true);
		test(sample, 0, false);
		test(sample, 6003, false);
	}
	
	private static void test(int[][] mat, int key, boolean expected) {
		int[] result = search(mat, key);
		if(expected) {
			assert(mat[result[0]][result[1]] == key);
			System.out.println(key + ": " + "(" + result[0] + ", " + result[1] + ")");
		} else {
			assert(result == null);
			System.out.println(key + " not found!");
		}
	}
	
	public static int locateRow(int[][] keys, int key) {
		int start = 0;
		int end = keys.length - 1;
		
		do {
			int mid = (start + end) / 2;
			
			// erster Wert der Zeile ist kleiner oder gleich
			// => gesuchter Wert kann in der aktuellen Zeile oder in den Zeilen darunter vorkommen
			if(keys[mid][0] <= key) {
				// falls die nchste Reihe nicht existiert
				// => gesuchter Wert kann nur in der aktuellen Zeile sein
				if(mid + 1 >= keys.length) {
					return mid;
				} else {
					// falls die nchste Reihe existiert, ihr erster Wert aber grer als der gesucht ist
					// => gesuchter Wert kann nur in der aktuellen Zeile sein
					if(keys[mid + 1][0] > key) {
						return mid;
					} else {
						start = mid + 1;
					}
				} 
				
			// erster Wert der Zeile ist echt grer
			// => gesuchter Wert kann nur in den Zeilen darber vorkommen
			} else {
				end = mid - 1;
			}
		} while(start <= end && start >= 0 && end <= keys.length);
		
		return -1;
	}
	
	public static int[] search(int[][] keys, int key) {
		int row = locateRow(keys, key);
		
		if(row == -1)
			return null;
		
		int start = 0;
		int end = keys[row].length - 1;
		
		do {
			int mid = (start + end) / 2;
			
			if(keys[row][mid] == key)
				return new int[]{row, mid};
		
			if(keys[row][mid] < key) {
				start = mid + 1;
			} else {
				end = mid - 1;
			}
			
		} while(start <= end && start >= 0 && end < keys[row].length);
		
		return null;
	}
}
